<?php

namespace Litecms\Rank;

use User;

class Rank
{
    /**
     * $rank_setting object.
     */
    protected $rank_setting;

    /**
     * Constructor.
     */
    public function __construct(\Litecms\Rank\Interfaces\RankSettingRepositoryInterface $rank_setting)
    {
        $this->rank_setting = $rank_setting;
    }

    /**
     * Returns count of rank.
     *
     * @param array $filter
     *
     * @return int
     */
    public function count()
    {
        return  0;
    }

    /**
     * Make gadget View
     *
     * @param string $view
     *
     * @param int $count
     *
     * @return View
     */
    public function gadget($view = 'admin.rank_setting.gadget', $count = 10)
    {

        if (User::hasRole('user')) {
            $this->rank_setting->pushCriteria(new \Litepie\Litecms\Repositories\Criteria\RankSettingUserCriteria());
        }

        $rank_setting = $this->rank_setting->scopeQuery(function ($query) use ($count) {
            return $query->orderBy('id', 'DESC')->take($count);
        })->all();

        return view('rank::' . $view, compact('rank_setting'))->render();
    }
}
