<?php

namespace Litecms\Rank\Repositories\Presenter;

use League\Fractal\TransformerAbstract;
use Hashids;

class RankSettingTransformer extends TransformerAbstract
{
    public function transform(\Litecms\Rank\Models\RankSetting $rank_setting)
    {
        return [
            'id'                => $rank_setting->getRouteKey(),
            'key'               => [
                'public'    => $rank_setting->getPublicKey(),
                'route'     => $rank_setting->getRouteKey(),
            ], 
            'downline_member_count' => $rank_setting->downline_member_count,
            'referal_count'     => $rank_setting->referal_count,
            'target_balance'    => $rank_setting->target_balance,
            'rank'              => $rank_setting->rank,
            'status'            => $rank_setting->status,
            'url'               => [
                'public'    => trans_url('rank/'.$rank_setting->getPublicKey()),
                'user'      => guard_url('rank/rank_setting/'.$rank_setting->getRouteKey()),
            ], 
            'status'            => trans('app.'.$rank_setting->status),
            'created_at'        => format_date($rank_setting->created_at),
            'updated_at'        => format_date($rank_setting->updated_at),
        ];
    }
}